package cn.ibizlab.core.sample.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import cn.ibizlab.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.core.sample.domain.IBIZSample0003;
import cn.ibizlab.core.sample.filter.IBIZSample0003SearchContext;
import cn.ibizlab.core.sample.service.IIBIZSample0003Service;

import cn.ibizlab.util.helper.CachedBeanCopier;
import cn.ibizlab.util.helper.DEFieldCacheMap;


import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import cn.ibizlab.core.sample.mapper.IBIZSample0003Mapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.alibaba.fastjson.JSONObject;
import org.springframework.util.StringUtils;

/**
 * 实体[示例实体03] 服务对象接口实现
 */
@Slf4j
@Service("IBIZSample0003ServiceImpl")
public class IBIZSample0003ServiceImpl extends ServiceImpl<IBIZSample0003Mapper, IBIZSample0003> implements IIBIZSample0003Service {


    protected cn.ibizlab.core.sample.service.IIBIZSample0003Service ibizsample0003Service = this;
    @Autowired
    @Lazy
    protected cn.ibizlab.core.sample.service.IIBIZSample0014Service ibizsample0014Service;

    protected int batchSize = 500;

    @Override
    @Transactional
    public boolean create(IBIZSample0003 et) {
        fillParentData(et);
        if(!this.retBool(this.baseMapper.insert(et))) {
            return false;
        }
        CachedBeanCopier.copy(get(et.getIbizsample0003id()), et);
        return true;
    }

    @Override
    @Transactional
    public void createBatch(List<IBIZSample0003> list) {
        list.forEach(item->fillParentData(item));
        this.saveBatch(list, batchSize);
    }

    @Override
    @Transactional
    public boolean update(IBIZSample0003 et) {
        fillParentData(et);
        if(!update(et, (Wrapper) et.getUpdateWrapper(true).eq("ibizsample0003id", et.getIbizsample0003id()))) {
            return false;
        }
        CachedBeanCopier.copy(get(et.getIbizsample0003id()), et);
        return true;
    }

    @Override
    @Transactional
    public void updateBatch(List<IBIZSample0003> list) {
        list.forEach(item->fillParentData(item));
        updateBatchById(list, batchSize);
    }

    @Override
    @Transactional
    public boolean remove(String key) {
        ibizsample0003Service.removeByPibizsample0003id(key);
        boolean result = removeById(key);
        return result ;
    }

    @Override
    @Transactional
    public void removeBatch(Collection<String> idList) {
        ibizsample0003Service.removeByPibizsample0003id(idList);
        removeByIds(idList);
    }

    @Override
    @Transactional
    public IBIZSample0003 get(String key) {
        IBIZSample0003 et = getById(key);
        if(et == null){
            et = new IBIZSample0003();
            et.setIbizsample0003id(key);
        }
        else {
        }
        return et;
    }

    @Override
    public IBIZSample0003 getDraft(IBIZSample0003 et) {
        fillParentData(et);
        return et;
    }

    @Override
    public boolean checkKey(IBIZSample0003 et) {
        return (!ObjectUtils.isEmpty(et.getIbizsample0003id())) && (!Objects.isNull(this.getById(et.getIbizsample0003id())));
    }
    @Override
    @Transactional
    public boolean save(IBIZSample0003 et) {
        if(!saveOrUpdate(et)) {
            return false;
        }
        return true;
    }

    @Override
    @Transactional
    public boolean saveOrUpdate(IBIZSample0003 et) {
        if (null == et) {
            return false;
        } else {
            return checkKey(et) ? getProxyService().update(et) : getProxyService().create(et);
        }
    }

    @Override
    @Transactional
    public boolean saveBatch(Collection<IBIZSample0003> list) {
        list.forEach(item->fillParentData(item));
        List<IBIZSample0003> create = new ArrayList<>();
        List<IBIZSample0003> update = new ArrayList<>();
        for (IBIZSample0003 et : list) {
            if (ObjectUtils.isEmpty(et.getIbizsample0003id()) || ObjectUtils.isEmpty(getById(et.getIbizsample0003id()))) {
                create.add(et);
            } else {
                update.add(et);
            }
        }
        if (create.size() > 0) {
            getProxyService().createBatch(create);
        }
        if (update.size() > 0) {
            getProxyService().updateBatch(update);
        }
        return true;
    }

    @Override
    @Transactional
    public void saveBatch(List<IBIZSample0003> list) {
        list.forEach(item->fillParentData(item));
        List<IBIZSample0003> create = new ArrayList<>();
        List<IBIZSample0003> update = new ArrayList<>();
        for (IBIZSample0003 et : list) {
            if (ObjectUtils.isEmpty(et.getIbizsample0003id()) || ObjectUtils.isEmpty(getById(et.getIbizsample0003id()))) {
                create.add(et);
            } else {
                update.add(et);
            }
        }
        if (create.size() > 0) {
            getProxyService().createBatch(create);
        }
        if (update.size() > 0) {
            getProxyService().updateBatch(update);
        }
    }


	@Override
    public List<IBIZSample0003> selectByPibizsample0003id(String ibizsample0003id) {
        return baseMapper.selectByPibizsample0003id(ibizsample0003id);
    }
    @Override
    public void removeByPibizsample0003id(Collection<String> ids) {
        this.remove(new QueryWrapper<IBIZSample0003>().in("pibizsample0003id",ids));
    }

    @Override
    public void removeByPibizsample0003id(String ibizsample0003id) {
        this.remove(new QueryWrapper<IBIZSample0003>().eq("pibizsample0003id",ibizsample0003id));
    }


    /**
     * 查询集合 当前数据
     */
    @Override
    public Page<IBIZSample0003> searchCurData(IBIZSample0003SearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<IBIZSample0003> pages=baseMapper.searchCurData(context.getPages(),context,context.getSelectCond());
        return new PageImpl<IBIZSample0003>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }

    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<IBIZSample0003> searchDefault(IBIZSample0003SearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<IBIZSample0003> pages=baseMapper.searchDefault(context.getPages(),context,context.getSelectCond());
        return new PageImpl<IBIZSample0003>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }

    /**
     * 查询集合 顶级数据
     */
    @Override
    public Page<IBIZSample0003> searchTopData(IBIZSample0003SearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<IBIZSample0003> pages=baseMapper.searchTopData(context.getPages(),context,context.getSelectCond());
        return new PageImpl<IBIZSample0003>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }



    /**
     * 为当前实体填充父数据（外键值文本、外键值附加数据）
     * @param et
     */
    private void fillParentData(IBIZSample0003 et){
        //实体关系[DER1N_IBIZSAMPLE0003_IBIZSAMPLE0003_PIBIZSAMPLE0003ID]
        if(!ObjectUtils.isEmpty(et.getPibizsample0003id())){
            cn.ibizlab.core.sample.domain.IBIZSample0003 pibizsample0003=et.getPibizsample0003();
            if(ObjectUtils.isEmpty(pibizsample0003)){
                cn.ibizlab.core.sample.domain.IBIZSample0003 majorEntity=ibizsample0003Service.get(et.getPibizsample0003id());
                et.setPibizsample0003(majorEntity);
                pibizsample0003=majorEntity;
            }
            et.setPibizsample0003name(pibizsample0003.getIbizsample0003name());
        }
    }




    @Override
    public List<JSONObject> select(String sql, Map param){
        return this.baseMapper.selectBySQL(sql,param);
    }

    @Override
    @Transactional
    public boolean execute(String sql , Map param){
        if (sql == null || sql.isEmpty()) {
            return false;
        }
        if (sql.toLowerCase().trim().startsWith("insert")) {
            return this.baseMapper.insertBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("update")) {
            return this.baseMapper.updateBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("delete")) {
            return this.baseMapper.deleteBySQL(sql,param);
        }
        log.warn("暂未支持的SQL语法");
        return true;
    }

    @Override
    public List<IBIZSample0003> getIbizsample0003ByIds(List<String> ids) {
         return this.listByIds(ids);
    }

    @Override
    public List<IBIZSample0003> getIbizsample0003ByEntities(List<IBIZSample0003> entities) {
        List ids =new ArrayList();
        for(IBIZSample0003 entity : entities){
            Serializable id=entity.getIbizsample0003id();
            if(!ObjectUtils.isEmpty(id)){
                ids.add(id);
            }
        }
        if(ids.size()>0) {
            return this.listByIds(ids);
        }
        else {
            return entities;
        }
    }





    public IIBIZSample0003Service getProxyService() {
        return cn.ibizlab.util.security.SpringContextHolder.getBean(this.getClass());
    }
}



